#include <string.h>

#include "object.h"
#include "xmalloc.h"
#include "Attribute.h"
#include "AttributeCache.h"

static attributeListT	*hashtable[0x4000] = {0};


// All identical strings passed through stringCache will have the same resulting address

attributeListT *
getAttributeListEntry(void)
{
	static attributeListT	*g_cacheP   = 0;
	static int				g_cache_lth = 0;
	static int				left        = 0;

	if (left == 0) {
		left  = 2048;
		g_cache_lth = sizeof(attributeListT) * 2048;
		g_cacheP = (attributeListT *) Xmalloc(g_cache_lth);
		if (!g_cacheP) {
			outofmemory();
	}	}
	return (g_cacheP + --left);
}

CAttribute *
attributeCache(const char *idP, const char *aviP)
{
	const char			*P;
	int					hash1, hash2;
	attributeListT		*cacheP;
	CAttribute			*attributeP;
	const char			*avi1P;
	int					c;

	hash1 = 0;
	for (P = idP; (c = *P); ++P) {
		hash1 <<= 1;
		hash1  ^= c;
	}
	if (aviP) {
		hash2 = 0;
		for (P = aviP; (c = *P); ++P) {
			hash2 <<= 1;
			hash2  ^= c;
		}
		hash1 ^= hash2;
	}
	hash1 &= 0x3FFF;
	for (cacheP = hashtable[hash1]; cacheP; cacheP = cacheP->nextP) {
		attributeP = cacheP->attributeP;
		if (strcmp(idP, attributeP->m_idP)) {
			continue;
		}
		if (!aviP) {
			if (!attributeP->m_aviP) {
				goto done;
			}
		} else {
			
			if (!(avi1P = attributeP->m_aviP)) {
				continue;
			}
			if (!strcmp(aviP, avi1P)) {
				goto done;
	}	}	}
	cacheP             = getAttributeListEntry();
	cacheP->nextP      = hashtable[hash1];
	cacheP->attributeP = attributeP = new CAttribute(idP, aviP);
	hashtable[hash1]   = cacheP;
done:
	return attributeP;
}
