#include <string.h>

#include "object.h"
#include "Attribute.h"
#include "LandscapeObject.h"
#include "LandscapeObject3D.h"
#include "LandscapeClassObject.h"
#include "EntityClass.h"
#include "EntityClassPair.h"
#include "RelationClass.h"

CRelationClass::CRelationClass(const char *idP)
{
	m_entityClassPairListP = 0;
	setId(idP);
	m_nextP                = 0;
}

void 
CRelationClass::putAttribute(const char *idP, const char *valueP)
{
	if (!strcmp(idP, "class_label")) {
		m_labelP = valueP;
	}
	CLandscapeClassObject::putAttribute(idP, valueP);
}

CEntityClassPair *
CRelationClass::getEntityClassPairs(void) const
{
	return m_entityClassPairListP;
}

void 
CRelationClass::addRelationConstraint(CEntityClassPair *epP)
{
	epP->m_nextP           = m_entityClassPairListP;
	m_entityClassPairListP = epP;
}

void 
CRelationClass::addRelationConstraint(CEntityClass *ec1P, CEntityClass *ec2P) 
{
	CEntityClassPair *atP;

	for (atP = m_entityClassPairListP; atP; atP = atP->m_nextP) {
		if (atP->equals(ec1P, ec2P)) {
			return;
	}	}
	addRelationConstraint(new CEntityClassPair(ec1P, this, ec2P));
}